module MixedModelsPermutations

using BlockDiagonals
using LinearAlgebra
using MixedModels # we add several methods
using Random
using SparseArrays
using StaticArrays
using Statistics
using StatsBase
using StatsModels
using Tables

using MixedModels: MixedModelBootstrap
using MixedModels: fixef!, stderror!
using MixedModels: getθ!, updateL! # setθ! is imported for extending
using MixedModels: replicate

import MixedModels: allpars, coefpvalues, issingular, setθ!, tidyβ, tidyσs, residuals

export MixedModelPermutation,
       nonparametricbootstrap,
       olsranef,
       permutation,
       permutationtest,
       residuals

include("mixedmodelpermutation.jl")
include("inflation.jl")
include("nonparametricbootstrap.jl")
include("permutation.jl")
include("ols.jl")

end
